require 'omniauth-oauth2'

module OmniAuth
  module Strategies
    class Codissimo < OmniAuth::Strategies::OAuth2
      # change the class name and the :name option to match your application name
      option :name, :codissimo

      option :client_options, {
        :site => "http://my.codissimo.co.uk",
        :authorize_url => "/oauth/authorize"
      }

      uid { raw_info["id"] }

      info do
        {
          :email => raw_info["email"],
          :name => raw_info["name"]
          # and anything else you want to return to your API consumers
        }
      end

      def raw_info
        @raw_info ||= access_token.get('/api/me.json').parsed
      end
      
      def request_phase
        redirect client.auth_code.authorize_url({:redirect_uri => callback_url, :app => request.params["app"]}.merge(authorize_params))
      end
    end
  end
end